#
# spec file for package gwenhywfar
#
# Copyright (c) 2014 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           gwenhywfar
Version:        4.9.0beta
Release:        9.22
Summary:        Multiplatform Helper Library for Other Libraries
License:        GPL-2.0+ and LGPL-2.1+
Group:          System/Libraries
Url:            http://www.aqbanking.de/
Source:         %{name}-%{version}.tar.gz
#Source:         http://www.aquamaniac.de/sites/download/download.php?package=01&release=72&file=01&dummy=gwenhywfar-4.9.0beta.tar.gz
BuildRequires:  doxygen
BuildRequires:  fdupes
BuildRequires:  gnutls-devel
BuildRequires:  gtk2-devel
BuildRequires:  libgcrypt-devel
BuildRequires:  libopenssl-devel
BuildRequires:  libqt4-devel
# For doc graphs
BuildRequires:  graphviz
BuildRequires:  graphviz-gd
BuildRequires:  xorg-x11-fonts
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
Gwenhywfar is a base library used to provide OS abstraction functions
for Linux, FreeBSD, OpenBSD, NetBSD, and Windows. It also includes some
often needed functions (for example, handling and parsing of
configuration files, reading and writingof XML files, and interprocess
communication).

%package tools
Summary:        Multiplatform Helper Library for Other Libraries - Tools
License:        GPL-2.0+ and LGPL-2.1+
Group:          System/Libraries
Requires:       libgwenhywfar60 = %{version}

%description tools
Gwenhywfar is a base library used to provide OS abstraction functions
for Linux, FreeBSD, OpenBSD, NetBSD, and Windows. It also includes
some often needed functions (for example, for handling and parsing of
configuration files, reading and writing of XML files, and interprocess
communication).

%package -n libgwenhywfar60-plugins
Summary:        Multiplatform Helper Library for Other Libraries - Plugins
License:        LGPL-2.1+
Group:          System/Libraries
Requires:       %{name} = %{version}

%description -n libgwenhywfar60-plugins
Gwenhywfar is a base library used to provide OS abstraction functions
for Linux, FreeBSD, OpenBSD, NetBSD, and Windows. It also includes
some often needed functions (for example, for handling and parsing of
configuration files, reading and writing of XML files, and interprocess
communication).

%package -n libgwenhywfar60
Summary:        Multiplatform Helper Library for Other Libraries
License:        LGPL-2.1+
Group:          System/Libraries
Recommends:     %{name}-lang
# Needed to make lang package installable
Provides:       %{name} = %{version}
Recommends:     libgwenhywfar60-plugins = %{version}

%description -n libgwenhywfar60
Gwenhywfar is a base library used to provide OS abstraction functions
for Linux, FreeBSD, OpenBSD, NetBSD, and Windows. It also includes
some often needed functions (for example, for handling and parsing of
configuration files, reading and writing of XML files, and interprocess
communication).

%package -n libgwengui-gtk2-0
Summary:        Multiplatform Helper Library for Other Libraries -- GTK+ UI Backend
License:        LGPL-2.1+
Group:          System/Libraries

%description -n libgwengui-gtk2-0
Gwenhywfar is a base library used to provide OS abstraction functions
for Linux, FreeBSD, OpenBSD, NetBSD, and Windows. It also includes
some often needed functions (for example, for handling and parsing of
configuration files, reading and writing of XML files, and interprocess
communication).

This package provides the GTK+ implementation of the generic UI toolkit.

%package -n libgwengui-qt4-0
Summary:        Multiplatform Helper Library for Other Libraries -- Qt UI Backend
License:        LGPL-2.1+
Group:          System/Libraries

%description -n libgwengui-qt4-0
Gwenhywfar is a base library used to provide OS abstraction functions
for Linux, FreeBSD, OpenBSD, NetBSD, and Windows. It also includes
some often needed functions (for example, for handling and parsing of
configuration files, reading and writing of XML files, and interprocess
communication).

This package provides the Qt implementation of the generic UI toolkit.

%package devel
Summary:        Multi-Platform Helper Library for Other Libraries
License:        LGPL-2.1+
Group:          Development/Libraries/C and C++
Requires:       glibc-devel
Requires:       libgwengui-gtk2-0 = %{version}
Requires:       libgwengui-qt4-0 = %{version}
Requires:       libgwenhywfar60 = %{version}

%description devel
Gwenhywfar is a base library used to provide OS abstraction functions
for Linux, FreeBSD, OpenBSD, NetBSD, and Windows. It also includes
some often needed functions (e.g. for handling and parsing of
configuration files, reading/writing of XML files, interprocess
communication etc).

%lang_package
%prep
%setup -q

%build
%configure\
	--enable-release\
	--enable-full-doc\
	--with-docpath=%{_datadir}/%{name}/apidoc\
	--with-openssl-libs=%{_libdir} \
        --with-qt4-libs=%{_libdir} \
	--disable-static \
	--with-pic
%__make %{?smp_mflags}
%__make srcdoc %{?smp_mflags}

%install
%makeinstall
%makeinstall install-srcdoc
pushd %{buildroot}%{_datadir}/%{name}/apidoc
    # we don't want another 'gwenhywfar' dir below docpath
    %__mv %{name}/* ./
    rm -rf %{name}
    # remove empty files
    `find -maxdepth 1 -type f -empty -print0 | xargs -0 echo %__rm -f`
popd
find %{buildroot} -type f -name "*.la" -delete -print
%find_lang %{name}
%fdupes %{buildroot}%{_datadir}/%{name}/apidoc

%clean
rm -rf %{buildroot}

%post -n libgwenhywfar60 -p /sbin/ldconfig

%postun -n libgwenhywfar60 -p /sbin/ldconfig

%post -n libgwengui-gtk2-0 -p /sbin/ldconfig

%postun -n libgwengui-gtk2-0 -p /sbin/ldconfig

%post -n libgwengui-qt4-0 -p /sbin/ldconfig

%postun -n libgwengui-qt4-0 -p /sbin/ldconfig

%files tools
%defattr (-, root, root)
%{_bindir}/gct-tool
%{_bindir}/gsa
%{_bindir}/mklistdoc
%{_bindir}/typemaker
%{_bindir}/typemaker2
%{_bindir}/xmlmerge
%{_datadir}/gwenhywfar/typemaker2/

%files -n libgwenhywfar60-plugins
%defattr (-, root, root)
%{_libdir}/gwenhywfar/plugins/60/*

%files -n libgwenhywfar60
%defattr (-, root, root)
%doc AUTHORS COPYING ChangeLog NEWS README TODO
%{_libdir}/libgwenhywfar.so.*
%{_libdir}/libgwengui-cpp.so.*
%dir %{_datadir}/gwenhywfar/
%{_datadir}/gwenhywfar/ca-bundle.crt
%{_datadir}/gwenhywfar/dialogs/
%dir %{_libdir}/gwenhywfar
%dir %{_libdir}/gwenhywfar/plugins
%dir %{_libdir}/gwenhywfar/plugins/60

%files -n libgwengui-gtk2-0
%defattr (-, root, root)
%{_libdir}/libgwengui-gtk2.so.*

%files -n libgwengui-qt4-0
%defattr (-, root, root)
%{_libdir}/libgwengui-qt4.so.*

%files devel
%defattr (-, root, root)
%{_bindir}/gwenhywfar-config
%dir %{_datadir}/aclocal
%{_datadir}/aclocal/gwenhywfar.m4
%doc %{_datadir}/gwenhywfar/apidoc/
%{_includedir}/gwenhywfar4/
%{_libdir}/*.so
%{_libdir}/pkgconfig/gwenhywfar.pc
%{_libdir}/pkgconfig/gwengui-gtk2.pc
%{_libdir}/pkgconfig/gwengui-qt4.pc

%files lang -f %{name}.lang

%changelog
* Mon Jan  6 2014 nico.kruber@gmail.com
- Update to version 4.9.0beta:
  + adds new code for cipher selection with SSL connections
    (still some problems with the Netbank, please report back)
  + Netbank works setting the GWEN_TLS_CIPHER_PRIORITIES
    environment variable to "NORMAL:-AES-256-CBC"
* Wed Oct 23 2013 nico.kruber@gmail.com
- Update to version 4.8.0beta:
  + new functions to work with dates (module GWEN_DATE,
    e.g.  GWEN_Date_GetLastHalfYearStart())
  + fix some errors in the layout of the  FOX 1.6 GUI module.
  + some improvements in typemaker2.
* Wed Aug 21 2013 nico.kruber@gmail.com
- Update to version 4.7.0beta:
  + contains improvements if the TypeMaker2 tool
  + fixes an error linking libgpg-error.so
  + adds some functions to the GWEN_XML and GWEN_DATE modules
    used by the new AqBanking version 5.0.31beta
  + Info: this is still beta because the MULTICACHE module is
    still work in progress
* Sun Jun 23 2013 nico.kruber@gmail.com
- Update to version 4.6.0beta:
  + adds a new module for cache handling and some widely used
    functionality
  + major (internal) improvements to typemaker2
  + complete German translation (thanks to Christian)
- Update to version 4.5.0beta:
  + adds some small changes for SEPA transactions needed by
    aqbanking
* Sat Mar  2 2013 coolo@suse.com
- update license to new format
* Tue Jul  3 2012 aj@suse.de
- Change lang package Requires to Recommends since it is not
  mandatory at runtime.
* Wed May  9 2012 Nico.Laus.2001@gmx.de
- Update to version 4.3.3:
  + do not use the deprecated libgcrypt interface for RSA keys
    anymore (allows compilation with newer libgcrypt versions)
* Fri Mar  9 2012 Nico.Laus.2001@gmx.de
- Update to version 4.3.2:
  + fixes network problems on Windows
* Mon Jan  2 2012 Nico.Laus.2001@gmx.de
- included %%{_datadir}/aclocal in the devel package
* Tue Dec 20 2011 Nico.Laus.2001@gmx.de
- removed gwenhywfar-gnutls-3.0.3.patch (fixed upstream in 4.3.1)
* Mon Dec 19 2011 Nico.Laus.2001@gmx.de
- Update to version 4.3.1:
  + this version is needed for AqBanking's new support for the
    optical chipTAN method
  + some improvements to the typemaker2 tool
* Wed Sep 28 2011 vuntz@opensuse.org
- Add gwenhywfar-gnutls-3.0.3.patch: fix build with gnutls 3.0.3.
* Wed Sep 21 2011 kruber@zib.de
- Update to version 4.3.0:
  + added a new method for converting charsets
  + better error handling in the build system
* Fri Aug 12 2011 dimstar@opensuse.org
- Add GPL-2.0+ tag to the main package and the tools subpackage, as
  this is the correct license for the tools and related sources.
  See also bnc#710065.
* Tue Aug  2 2011 dimstar@opensuse.org
- Update to version 4.2.1:
  + Make QLabel in GUI wrap words.
  + Relaxed http code.
* Sat Jul 16 2011 malcolmlewis@opensuse.org
- Update to version 4.2.0:
  + Marked argument list of GWEN_StringList_new() as void.
  + Added keyword "void" to functions with empty argument list.
  + Let typemaker tools use "void" for empty argument lists in
    constructors.
  + Added field "CustomerId" to GWEN_Crypt_Token_Context.
  + Added function GWEN_DB_GetParentGroup().
  + Added line for "hasKeyNumber" flag.
  + Show customer if available.
  + Added some tm2 files to ignore list.
  + typemaker2: added type uint64_t.
  + Improved and fixed GWEN_TLV, added functions
    GWEN_TLV_ReadHeader() and GWEN_TLV_WriteHeader().
  + Started working on a simple archiver.
  + Fixed a few bugs in new TLV code.
  + Added tool "gsa" ("Gwen's simple archiver").
  + Improved HTTP handling:
  - added function GWEN_SyncIo_Http_RecvBodyToSio().
  - added function GWEN_HttpSession_RecvPacketToFile().
  + Added function GWEN_Directory_GetAbsoluteFolderPath().
  + Added convenience function GWEN_Sar_UnpackArchive().
  + Added code and commands to sign a sar archive.
  + Improved progress handling in network code.
  + Fixed GWEN_MDigest__HashFileTree().
  + Added missing include.
  + Various bug fixes and code cleanup.
- Update Url as Gwenhywfar is now being hosted at
  http://www.aqbanking.de/.
- Update spec file License field from LGPLv2.1+ to LGPL-2.1+ to
  conform with spdx.org identifier.
- Minor reformatting in spec file.
- Remove service usage, following the new consensus on Factory
  packaging.
* Sat Jun 11 2011 Nico.Laus.2001@gmx.de
- Update to version 4.1.0:
  + new code for sorting any GWEN_LIST
  + some bug fixes
* Thu Mar 17 2011 Nico.Laus.2001@gmx.de
- Update to version 4.0.9:
  + fixes a bug in the Qt4 frontend
  + fixes a bug in the LIST1 module
  + fixes xml file generation using the XMLDB module
* Sun Feb 20 2011 Nico.Laus.2001@gmx.de
- Update to version 4.0.7:
  + fixes problems with smsTAN/mTAN
  + keep the focus chain intact in QT4 GUI
- Update to version 4.0.5:
  + fixes a bug with chunked HTTP
* Thu Jan 27 2011 Nico.Laus.2001@gmx.de
- Update to version 4.0.4:
  + fixes a bug in the GTK2 front-end
  + fixes a bug in the network code on MaxOSX
* Sat Jan 15 2011 Nico.Laus.2001@gmx.de
- Update to version 4.0.3:
  + improved error messages
  + several bug fixes
* Fri Dec 10 2010 vuntz@opensuse.org
- Update to version 4.0.2:
  + Fix GTK+ password entry.
  + Build fixes.
- Split libgwengui_gtk2-0 and libgwengui_qt4-0 subpackages, as we
  don't want libgwenhywfar60 to depend on both GTK+ and Qt.
- Add libgwengui-gtk2-0 and libgwengui-qt4-0 Requires to devel
  package.
* Thu Sep  2 2010 dimstar@opensuse.org
- Update to version 4.0.1:
  + Fix gtk2 building for Windows
  + Improved HTTP handling.
* Thu Sep  2 2010 dimstar@opensuse.org
- Update to version 4.0.0:
  + Gwenhywfar4 features a new XML-based platform and toolkit.
  + Independent dialog framework which is heavily used by
    AqBanking5.
  + Provide generic UI implementations for GTK-2, Qt-4, and
    FOX-1.6.
  + The network code has been rewritten and thereby changed from
    asynchronous to synchronous access to fix some strange timeout
    problems.
  + Many bugs and problems have been fixed.
- Add gtk2-devel and libqt4-devel BuildRequires.
- Follow the so bump of the library, change the library package
  name to from libgwenhywfar47 to libgwenhywfar60
- Remove Provides/Obsoletes of gwenhywfar$sover from
  libgwenhywfar$sover-plugins: it was there for upgrades of the old
  package.
- Pass --with-qt4-libs=%%{_libdir} to configure.
- Use _smp_mflags.
* Sat Jan  2 2010 vuntz@opensuse.org
- Update to version 3.11.3:
  + GWEN_DB: Escape and unescape group names upon read/write,
    respectively.
  + Show a more informative erro message when a false chipcard has
    been inserted.
- Changes from version 3.11.2:
  + Add unittest for GWEN_Url_fromString that checks those cases
    that work.
  + Do not abort on unknown port number.
  + Improve error messages.
  + Check for NULL token name before crashing in FSLock_new so that
    a more clear error message is printed instead.
  + Decrease debug level of non-critical info message.
  + Improved handling of file/directory locks on POSIX systems.
  + Windows fixes.
  + Build system fixes.
* Tue Dec 15 2009 vuntz@opensuse.org
- Remove unneeded libxml2-devel BuildRequires.
- Remove autoreconf call since we have no patch.
- Rework the install section to be more readable.
- Rename gwenhywfar47 to libgwenhywfar47-plugins, since it's a more
  appropriate name. Add Provides/Obsoletes for the old package.
- Make libgwenhywfar47 recommends the libgwenhywfar47-plugins
  package. Also remove any Requires/Recommends from the main
  package to libgwenhywfar47-plugins or gwenhywfar47 since
  libgwenhywfar47 should be enough.
- Rename the main package to gwenhywfar-tools and move some tools
  from devel subpackage there.
- Split a lang package, that is required by the library package,
  and make the library package now provide gwenhywfar to make the
  lang package installable.
* Tue Dec  1 2009 Nico.Laus.2001@gmx.de
- Update to version 3.11.1:
  + compile on windows
- Changes from version 3.11.0:
  + fixes some minor bugs
  + extended the HTTP session module to allow testing connections
    (used by the AqBanking-EBICS module to download new
    certificates)
  + special support for statistical modules has been removed again
    to simplify the build system
- Changes from version 3.10.1:
  + fixes a bug in GWEN_Url_fromString() and supports username and
    password with HTTP proxies (tested with squid2)
  + fixed a problem on MacOSX
- Changes from version 3.10.0
  + adds new support for RDH-10
  + includes the tool typemaker2, an improved version of the old
    typemaker which includes support for AqFinance
  + added the data type GWEN_DATE which is now used by AqFinance
    instead of GWEN_TIME when only a date is required instead of a
    full timestamp
* Mon Oct 12 2009 crrodriguez@opensuse.org
- fix dependencies (was using >= instead of =)
* Thu Sep  3 2009 sbrabec@suse.cz
- Typo fix in dependencies.
* Fri Aug 14 2009 sbrabec@suse.cz
- Split package to allow parrallel installation of more versions.
* Wed Jun 24 2009 mkudlvasr@suse.cz
- update to version 3.8.3
  * lots of bugs fixed, lots of new features
- removed patch0 (tests/gwenhywfar.c). not needed anymore
* Thu Jan 24 2008 coolo@suse.de
- fixing open call
* Fri Nov  9 2007 crrodriguez@suse.de
- update to version 2.6.2
  * Release is only interesting for windows or NetBSD users
- disable static libraries
- remove "la" files
- remove unnedded dependency on libopenssl-devel in the -devel package
* Fri Jul 27 2007 sbrabec@suse.cz
- Updated to version 2.6.1:
  * Minor bugs have been fixed.
  * Cross-compiling is now supported.
  * Some missing list functions have been added.
  * Decreases the verbosity.
  * Makes gwenhywfar completely relocatable using binreloc.
- Split package according to shared library packaging policy.
- Build with libxml2.
- Build and create api docs.
* Mon Oct  2 2006 sbrabec@suse.cz
- Updated to version 2.4.1:
  * bug fixes
  * removed debugging messages
  * clean up the API
* Fri Sep 15 2006 jhargadon@suse.de
- update to version 2.4.0
- This release adds GWEN_DBIO plugin which writes GWEN_DB's as XML files
* Tue Jun 20 2006 stbinner@suse.de
- Update to version 2.3.0:
  * Adds a new module for fast lookup of objects via integer IDs.
  * Adds a storage module to be used by further projects.
* Thu May 11 2006 sbrabec@suse.cz
- Updated to version 2.2.0.
* Wed Jan 25 2006 mls@suse.de
- converted neededforbuild to BuildRequires
* Mon Jan 16 2006 sbrabec@suse.cz
- Updated to version 1.19.2.
* Wed Oct 19 2005 sbrabec@suse.cz
- New SuSE package, version 1.18.0.
  Based on spec file from Rajesh Singh <rajeshsingh.geo@yahoo.com>.
